<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>factorize</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="divide.html">&lt;&lt; divide</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_9ebe4d1d576a019be0dd541ed7338bc5.html">arithmetic</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="millerrabin.html">millerrabin &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">bigint</a> &gt;&gt; <a href="section_9ebe4d1d576a019be0dd541ed7338bc5.html">arithmetic</a> &gt; factorize</span>

    <br /><br />
    <div class="refnamediv"><h1 class="refname">factorize</h1>
    <p class="refpurpose">bigint factorization</p></div>


<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">n :</span>
            <dd><p class="para">bigint</p></dd></dt>
        <dt><span class="term">P,A :</span>
            <dd><p class="para">mbigint</p></dd></dt>
        <dt><span class="term">str :</span>
            <dd><p class="para">string</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">bigint integer factorization by trivial division
<ul class="itemizedlist"><li><p class="para">P is the list of prime factors <span><img src='./_LaTeX_factorize.xml_1.png' style='position:relative;top:7px;width:17px;height:16px'/></span></p></li>
<li><p class="para">A is the list of prime factors exponents <span><img src='./_LaTeX_factorize.xml_2.png' style='position:relative;top:7px;width:18px;height:16px'/></span></p></li>
<li><p class="para">str is a string representing the decomposition <span><img src='./_LaTeX_factorize.xml_3.png' style='position:relative;top:9px;width:196px;height:26px'/></span></p></li></ul></p>
   <p class="para"></p>
   <p class="para"></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><span class="scilabid">n</span><span class="scilaboperator">=</span><span class="scilabid">bigint</span><span class="scilabopenclose">(</span><span class="scilabnumber">2</span><span class="scilaboperator">^</span><span class="scilabnumber">3</span><span class="scilaboperator">*</span><span class="scilabnumber">5</span><span class="scilaboperator">*</span><span class="scilabnumber">17</span><span class="scilaboperator">^</span><span class="scilabnumber">4</span><span class="scilabopenclose">)</span>
<span class="scilabid">str</span><span class="scilaboperator">=</span><span class="scilabid">factorize</span><span class="scilabopenclose">(</span><span class="scilabid">n</span><span class="scilabopenclose">)</span>
<a class="scilabmacro" href="scilab://evstr">evstr</a><span class="scilabopenclose">(</span><span class="scilabid">str</span><span class="scilabopenclose">)</span><span class="scilaboperator">==</span><span class="scilabid">n</span>           <span class="scilabcomment">// verify</span>
<span class="scilabopenclose">[</span><span class="scilabid">str</span><span class="scilabdefault">,</span><span class="scilabid">P</span><span class="scilabdefault">,</span><span class="scilabid">A</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">factorize</span><span class="scilabopenclose">(</span><span class="scilabid">n</span><span class="scilabopenclose">)</span>  <span class="scilabcomment">// retrive factors and exponents</span>
<span class="scilabid">factorize</span><span class="scilabopenclose">(</span><span class="scilabnumber">43691</span><span class="scilabopenclose">)</span>        <span class="scilabcomment">// a prime number</span>
<span class="scilabid">n</span><span class="scilaboperator">=</span><a class="scilabcommand" href="scilab://prod">prod</a><span class="scilabopenclose">(</span><a class="scilabmacro" href="scilab://primes">primes</a><span class="scilabopenclose">(</span><span class="scilabnumber">17</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilaboperator">*</span><a class="scilabcommand" href="scilab://prod">prod</a><span class="scilabopenclose">(</span><a class="scilabmacro" href="scilab://primes">primes</a><span class="scilabopenclose">(</span><span class="scilabnumber">9</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilaboperator">*</span><span class="scilabid">bigint</span><span class="scilabopenclose">(</span><span class="scilabnumber">1e8</span><span class="scilabopenclose">)</span>
<span class="scilabid">factorize</span><span class="scilabopenclose">(</span><span class="scilabid">n</span><span class="scilabopenclose">)</span>       <span class="scilabcomment">// = 2^(10)*3^(2)*5^(10)*7^(2)*11*13*17</span>
<span class="scilabcomment">// stop search when p^2 </span><span class="scilabcomment">&#0062;</span><span class="scilabcomment">n ( below last prime tested p=223~ sqrt(51061)  )</span>
<span class="scilabid">n</span><span class="scilaboperator">=</span><span class="scilabopenclose">(</span><span class="scilabid">bigint</span><span class="scilabopenclose">(</span><span class="scilabnumber">2</span><span class="scilabopenclose">)</span><span class="scilaboperator">^</span><span class="scilabnumber">53</span><span class="scilabopenclose">)</span><span class="scilaboperator">*</span><span class="scilabid">bigint</span><span class="scilabopenclose">(</span><span class="scilabnumber">51061</span><span class="scilabopenclose">)</span>
<span class="scilabid">factorize</span><span class="scilabopenclose">(</span><span class="scilabid">n</span><span class="scilabopenclose">)</span> <span class="scilabcomment">// =2^(53)*51061</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="bigint.html" class="link">bigint</a></li>
   <li class="member"><a href="scilab://factor" class="link">factor</a></li>
   <li class="member"><a href="millerrabin.html" class="link">millerrabin</a></li></ul></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">Philippe Roux</li></ul></div>
    <br />

    <div class="manualnavbar">
    <table width="100%">
    <tr><td colspan="3" class="next"><a href="http://bugzilla.scilab.org/enter_bug.cgi?product=Scilab%20software&component=Documentation%20pages" class="ulink">Report an issue</a></td></tr>
<tr>
      <td width="30%">
    	<span class="previous"><a href="divide.html">&lt;&lt; divide</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_9ebe4d1d576a019be0dd541ed7338bc5.html">arithmetic</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="millerrabin.html">millerrabin &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
